#!/bin/ash
# /root/.waimea/waimea-full-menu.sh # Requiert : / Requires: ROXFiler, replaceit.
# Goal: create a full-menu for the waimea WM. /
# Objectif : créer un menu complet pour le gest. de fen. waimea.
####### Note ######
## Useful when creating "list2" from scratch, if the contents of the default categories
## contained in liste2 vary greatly from what you have on your Pup.
###
# cd /usr/share/applications
# grep Categories *.desktop | awk -F"=" '{ print $NF}' | sort -u  > /root/.waimea/build-menu/liste
# Clean up the "liste", and then issue this command:
# sort -u liste > /root/.waimea/build-menu/liste2
#################
# © Christian L'Écuyer, Gatineau (Qc), Canada, 17-21 déc. 2017. GPL3
# (Alias musher0 [forum Puppy].) #
################# # https://opensource.org/licenses/GPL-3.0
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#    	This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#    	You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
##########
#	Ce programme est libre : vous pouvez le redistribuer ou modifier
#	selon les termes de la Licence Publique Générale GNU publiée par la
#	Free Software Foundation (v. 3 ou toute version ultérieure choisie par
#	vous).
#		Ce programme est distribué dans l'espoir qu'il sera utile, mais SANS
#	AUCUNE GARANTIE, ni explicite ni implicite, y compris des garanties de
#	commercialisation ou d'adaptation à un but spécifique. Pour obtenir plus
# 	de détails, veuillez vous reporter au texte de cette licence à
#	https://opensource.org/licenses/GPL-3.0 pour le texte officiel, à
#	http://www.linux-france.org/article/these/gpl.html pour une traduction et à
#	https://fr.wikipedia.org/wiki/Licence_publique_générale_GNU pour une
#	explication en français.
################
LC_ALL=C
rm -rf /root/.waimea/Categs/*;rm -rf /root/.waimea/Categs-meta/*
rm -f /root/.waimea/full-menu;mkdir -p /root/.waimea/Categs

[ ! -d /root/.waimea/build-menu ] && mkdir -p /root/.waimea/build-menu

AppsDir=/usr/share/applications
CatDir=/root/.waimea/Categs

### # Fonctions
ProgS () { prog="";while read prog;
do nom="`basename $prog`";nom="${nom%.*}"
	echo -e "\t\t[item] ($nom) {rox $prog.desktop}" >> $listDest
done < $listOrig; }

LignSbmn () { echo "[submenu] ($Sbmn)" > /root/.waimea/Categs-meta/$Sbmn.lst; }

TitrE () { echo -e "[submenu] ($Titre)" > /root/.waimea/Categs-meta/$Sbmn.lst; }

Groupe () { if [ "`wc -l < $CatDir/$i.lst`" -gt "2" ];then
	cat $CatDir/$i.lst >> /root/.waimea/Categs-meta/$Sbmn.lst
	rm -f $CatDir/$i.lst
fi; }

LignFin () { echo -e "\t[item] (--) {nop}\n[end]\n" >> /root/.waimea/Categs-meta/$Sbmn.lst; }
###

cd /root/.waimea/build-menu

Categ=""
while read Categ;do
	echo -e "\t[submenu] ($Categ)" > /root/.waimea/Categs/$Categ.lst
	grep -E "=$Categ" $AppsDir/*.desktop | grep -E -v "default|idle|JWM|jwm|restart" | awk -F"." '{ print $1 }' | sort -u >> /root/.waimea/Categs/$Categ
	listOrig=/root/.waimea/Categs/$Categ;listDest="$listOrig.lst"
	ProgS
	echo -e "	\t[item] (--) {nop}\n\t[end]\n" >> /root/.waimea/Categs/$Categ.lst
done < /root/.waimea/build-menu/liste2

# Sections
replaceit --input=/root/.waimea/Categs/Internet.lst --wholeline Wizard " "
Sbmn=w3;LignSbmn # 3w
i="";for i in Email Internet IRCClient Network P2P Telephony;do Groupe;done;LignFin

Sbmn=images;LignSbmn # Graphiques
i="";for i in Graphic Presentation Viewer X-GraphicUtility;do Groupe;done;LignFin

Sbmn=multimedia;LignSbmn # Multimedia
i="";for i in Audio DiskBurning Video;do Groupe;done;LignFin

Sbmn=filemanage;if [ "${LANG:0:2}" = "en" ];then # FileManagement
	echo "[submenu] (file management)" > /root/.waimea/Categs-meta/$Sbmn.lst
elif [ "${LANG:0:2}" = "fr" ];then
	echo "[submenu] (gest. de fich.)" > /root/.waimea/Categs-meta/$Sbmn.lst
fi
i="";for i in Archiving File;do Groupe;done;LignFin

Sbmn=grooming;if [ "${LANG:0:2}" = "en" ];then # Puppy Grooming
	echo "[submenu] (Grooming Puppy)" > /root/.waimea/Categs-meta/$Sbmn.lst
elif [ "${LANG:0:2}" = "fr" ];then
	echo "[submenu] (entretien du Puppy)" > /root/.waimea/Categs-meta/$Sbmn.lst
fi
### Cas spécial ######
Dest=/root/.waimea/Categs/X-Desktop-trimmed;listOrig="$Dest"
> $listOrig
while read line;do # Évite les redites
	if [ "`grep $line /root/.waimea/Categs/X-Desktop-appearance`" != "$line" ];then
		echo "$line" >> $listOrig
	fi
done < /root/.waimea/Categs/X-Desktop
listDest="$Dest.lst"
echo -e "\t[submenu] (X-Desktop)" > "$listDest"
ProgS
echo -e "\t[item] (--) {nop}\n\t[end]" >> "$listDest"
rm -f /root/.waimea/Categs/X-Desktop;rm -f /root/.waimea/Categs/X-Desktop.lst

################ On reprend le traitement normal ici.
i="";for i in X-Desktop-trimmed X-Desktop-appearance Wizard;do
	Groupe;done;LignFin

Sbmn=office;case "${LANG:0:2}" in fr)Titre="bureautique" ;; # office
	en|*)Titre="$Sbmn" ;;
esac;TitrE
i="";for i in X-Business Calculator Database X-Document;do Groupe;done;LignFin

Sbmn=technical;case "${LANG:0:2}" in fr)Titre="technique" ;; # System stuff
	en|*)Titre="$Sbmn" ;;
esac;TitrE
i="";for i in Development Emulator Monitor Security System TerminalEmulator Utility;do
	Groupe;done;LignFin
#
ls -1 /root/.waimea/Categs/*.lst > /root/.waimea/build-menu/reste # For the rest
line="";while read line;do
	[ "`wc -l $line | cut -d' ' -f 1`" -lt "3" ] && rm -f $line || mv $line /root/.waimea/Categs-meta/
done < /root/.waimea/build-menu/reste
#

Sbmn="full-menu";if [ "${LANG:0:2}" = "en" ];then # We assemble
	echo -e "[submenu] (full menu)" > /root/.waimea/$Sbmn
elif [ "${LANG:0:2}" = "fr" ];then
	echo -e "[submenu] (menu complet)" > /root/.waimea/$Sbmn
fi
cat /root/.waimea/Categs-meta/*.lst >> /root/.waimea/$Sbmn
Titre="";case "${LANG:0:2}" in fr)Titre="Rafraichir ce menu" ;;
	en|*)Titre="Refresh sub-menu" ;;
esac
echo -e "\t[item] (--) {nop}\n\t[item] ($Titre) {/root/.waimea/build-menu/waimea-full-menu.sh}
	[item] (--) {nop}\n[end]" >> /root/.waimea/$Sbmn

#
RPLCT="replaceit --input=/root/.waimea/full-menu" # Touch-ups & Translations
line="";while read line;do $RPLCT "${line%+*}" "${line#*+}" "{submenu"
done < /root/.waimea/build-menu/touch-up

case "${LANG:0:2}" in fr) # Traductions
	line="";while read line;do $RPLCT "${line%+*}" "${line#*+}" "{submenu"
	done < /root/.waimea/build-menu/trad ;;
esac

LC_ALL="";rm -f /root/.waimea/build-menu/reste
# Temps de création, v. française : approx. 1,85 seconde sur ma machine.
# The English version will take less time.
### 30 ###
